
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern void	Error(char *msg);

typedef struct {
		double	x0,y0,l1,l2,h,v;
	} Oval;

#define NOO	10	/* number of ovals */

static Oval	O[NOO]={{ 0.0 , 0.0   ,0.92 ,0.69  , 90.0, 2.0 },
			{ 0.0 ,-0.0184,0.874,0.6624, 90.0,-0.98},
			{ 0.22, 0.0   ,0.31 ,0.11  , 72.0,-0.02},
			{-0.22, 0.0   ,0.41 ,0.16  ,108.0,-0.02},
			{ 0.0 , 0.35  ,0.25 ,0.21  , 90.0, 0.01},
			{ 0.0 , 0.1   ,0.046,0.046 ,  0.0, 0.01},
			{ 0.0 ,-0.1   ,0.046,0.046 ,  0.0, 0.01},
			{-0.08,-0.605 ,0.046,0.023 ,  0.0, 0.01},
			{ 0.0 ,-0.605 ,0.023,0.023 ,  0.0, 0.01},
			{ 0.06, -0.605,0.023,0.023 , 90.0, 0.01}};

int	main(int argc,char **argv)
{
	int	N,M,o,m,n;
	double	*X[NOO],*Y[NOO],*Z[NOO],u;
	FILE	*file;

	if (argc!=4) Error("usage : 2d_hp_sg Nr M HP_SG.bin");

	if ((N=atoi(argv[1]))<=0) Error("bad pixel number.");

	if ((M=atoi(argv[2]))<=0) Error("bad rotation step.");

	if ((X[0]=(double *)malloc(sizeof(double)*NOO*M))==NULL ||
	    (Y[0]=(double *)malloc(sizeof(double)*NOO*M))==NULL ||
	    (Z[0]=(double *)malloc(sizeof(double)*NOO*M))==NULL)
	    Error("memory allocation error.");

	u=M_PI/(double)M;
	for (o=0; o<NOO; o++)
{
	double	w,t,c,s,
		x0=O[o].x0,y0=O[o].y0,
		a=O[o].l1*O[o].l1,b=O[o].l2*O[o].l2,
		h=O[o].h*M_PI/180.0,v=2.0*O[o].l1*O[o].l2*O[o].v;

	if (o>0) {
	    X[o]=X[o-1]+M; Y[o]=Y[o-1]+M; Z[o]=Z[o-1]+M;
	}
	for (m=0; m<M; m++) {
	    w=(t=u*(double)m)-h;
	    X[o][m]=x0*cos(t)+y0*sin(t);
	    c=cos(w); s=sin(w); Y[o][m]=v/(Z[o][m]=a*c*c+b*s*s);
	}
}
	if (argv[3][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[3],"wb"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d\n",N,M);
	
	u=2.0/(double)(N-1);
	for (m=0; m<M; m++)
	for (n=0; n<N; n++)
{
	double	d,w,r=u*(double)n-1.0,p=0.0;

	for (o=0; o<NOO; o++) {
	    d=r-X[o][m]; if ((w=Z[o][m]-d*d)>=0.0) p+=(Y[o][m]*sqrt(w));
	}
	(void)fwrite(&p,sizeof(double),(size_t)1,file);
}
	if (file!=stdout) (void)fclose(file);

	free(Z[0]); free(Y[0]); free(X[0]); return 0;
}
