
#include <stdio.h>
#include <stdlib.h>

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*XP,*SG;
	char	str[LEN];
	int	Nu,Nw,Nt,W,t,w,u;
	double	p;

	if (argc!=4) Error("usage : xp2sg XP.bin slice SG.bin");

	if (argv[1][0]=='-')
	    XP=stdin;
	else
	    if ((XP=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,XP)==NULL ||
	    sscanf(str,"%d %d %d",&Nu,&Nw,&Nt)!=3 ||
	    Nu<=0 || Nw<=0 || Nt<=0) Error("bad projection data size.");

	if ((W=atoi(argv[2]))<0 || W>=Nw) Error("bad slice number.");

	if (argv[3][0]=='-')
	    SG=stdout;
	else
	    if ((SG=fopen(argv[3],"wb"))==NULL) Error("file not open.");

	(void)fprintf(SG,"%d\t%d\n",Nu,Nt);

	for (t=0; t<Nt; t++)
	for (w=0; w<Nw; w++)
	for (u=0; u<Nu; u++) {
	    if (fread(&p,sizeof(double),1,XP)!=1)
		Error("projection data read error.");

	    if (w==W) (void)fwrite(&p,sizeof(double),1,SG);
	}
	if (SG!=stdout) (void)fclose(SG);
	if (XP!=stdin ) (void)fclose(XP); return 0;
}
