
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sgif.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE		*BIN,*GIF;
	char		str[LEN];
	int		Nu,Nw,Nt,w,t,u;
	double		pt,base=0.0,step=1.0/255.0;
	unsigned char	**PV;

	if (argc!=3 && argc!=5)
	    Error("usage : xp2xt XP.bin {base step} XT.gif");

	if (argv[1][0]=='-')
	    BIN=stdin;
	else
	    if ((BIN=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,BIN)==NULL ||
	    sscanf(str,"%d %d %d",&Nu,&Nw,&Nt)!=3 ||
	    Nu<=0 || Nw<=0 || Nt<=0) Error("bad projection data size.");

	if (argc==5) {
	    base=atof(argv[2]);
	    if ((step=atof(argv[3]))<=0.0) Error("bad XT-value step.");
	}
	if ((PV=(unsigned char **)malloc(sizeof(unsigned char *)*Nw))==NULL ||
	    (*PV=(unsigned char *)malloc(sizeof(unsigned char)*Nw*Nu))==NULL)
	    Error("memory allocation error.");

	for (w=1; w<Nw; w++) PV[w]=PV[w-1]+Nu;

	if (argv[argc-1][0]=='-')
	    GIF=stdout;
	else
	    if ((GIF=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	InitStoreGIF(GIF,Nu,Nw,StoreGIF_Gray,StoreGIF_Gray,StoreGIF_Gray);

	for (t=0; t<Nt; t++) {
	    for (w=0; w<Nw; w++)
	    for (u=0; u<Nu; u++) {
		if (fread(&pt,sizeof(double),1,BIN)!=1)
		    Error("projection data read error.");

		PV[w][u]=((pt=exp(-pt)-base)<=0.0)?0:
			 ((pt/=step)>=255.0)?255:
			 (unsigned char)(pt+0.5);
	    }
	    StoreGIF(GIF,0,0,Nu,Nw,NULL,NULL,NULL,PV);
	}
	TermStoreGIF(GIF); if (GIF!=stdout) (void)fclose(GIF);

	free(PV); if (BIN!=stdin) (void)fclose(BIN);

	return 0;
}
